package ch.usi.dag.jp2.dump;

import java.io.IOException;

import ch.usi.dag.jp2.runtime.CCTNode;

/**
 * Each dumper is assumed to have a constructor accepting a single
 * {@link java.io.PrintStream}.
 * 
 * @author Andreas Sewe
 */
public interface Dumper {
    
        /**
     * Dumps the calling context tree represented by the give node.
     * 
     * Should be invoked on the ROOT node.
     * Must be called with activated DIB
     */
    void dump(CCTNode node) throws IOException;
}
