package ch.usi.dag.jp2.runtime;

import java.util.List;

/**
 * @author Andreas Sewe
 */
public interface CallingContextTreeNode {
    
    public String getDeclaringClass();
    
    public String getName();
    
    public List<String> getParams();
    
    public String getReturn();
    
    public int getBytecodeIndex();
    
    public long getExecutionCount();
    
    public long getExecutedInstructions();
    
    public List<? extends CallingContextTreeNode> collectCallees();
    
    public List<Integer> getBasicBlockSizes();
    
    public List<Long> getBasicBlockExecutionCounts();
}
